!function() {
    window.FileFeature = {
		createTempFile : function(option) {
			var resultOption = $.extend({
				'fileNameKey' : undefined,
				'suffix' : 'tmp',
				'onSuccess' : function(fileEntry) {},
				'onError' : function() {}
			}, option);
			
			FileFeature.getTempDirectory({
				'fileNameKey' : resultOption.fileNameKey,
				'onSuccess' : function(tempDirectory) {
					var tempFileName = Inner.data.generateTempFileName({
						'suffix' : resultOption.suffix
					});
					CordovaFileFeature.getFile({
						'directoryEntry' : tempDirectory,
						'fileName' : tempFileName,
						'neededToCreate' : true,
						'onSuccess' : function(targetFileEntry) {
							resultOption.onSuccess(targetFileEntry);
						},
						'onError' : function(error) {
		    				console.error('feature/file FileFeature.createTempFile() getFile() error : '
		    						+ JSON.stringify(error));
							resultOption.onError();
						}
					});
				},
				'onError' : function() {
					resultOption.onError();
				}
			});
		},
		getCdvFile : function(option) {
			var resultOption = $.extend({
				'filePath' : undefined,
				'onSuccess' : function(targetFileEntry) {},
				'onError' : function() {}
			}, option);
			
			CordovaFileFeature.getCdvFile({
				'filePath' : resultOption.filePath,
				'onSuccess' : function(targetFileEntry) {
					resultOption.onSuccess(targetFileEntry);
				},
				'onError' : function() {
					resultOption.onError();
				}
			});
		},
		upload : function(option) {
			var resultOption = $.extend({
				'fileEntry' : undefined,
				'uploadUrl' : undefined,
				'onSuccess' : function(result) {},
				'onError' : function() {}
			}, option);
			
			CordovaFileFeature.upload({
				'fileEntry' : resultOption.fileEntry,
				'uploadUrl' : resultOption.uploadUrl,
				'onSuccess' : function(result) {
					resultOption.onSuccess(result);
				},
				'onError' : function() {
					resultOption.onError();
				}
			});
		},
		getTempDirectory : function(option) {
			var resultOption = $.extend({
				'fileNameKey' : undefined,
				'onSuccess' : function(tempDirectory) {},
				'onError' : function() {}
			}, option);
			
			CordovaFileFeature.getRoot({
				'onSuccess' : function(root) {
					var directoryName = 'huibenxia/temp_' + resultOption.fileNameKey
							+ '/.nomedia';
					FileFeature.getDirectoryByPath({
						'parentDirectoryEntry' : root,
						'directoryPath' : directoryName,
						'onSuccess' : function(directoryEntry) {
		    				resultOption.onSuccess(directoryEntry);
						},
						'onError' : function() {
		    				console.error('feature/file FileFeature.getTempDirectory().getRoot()');
							resultOption.onError();
						}
					});
				},
				'onError' : function() {
    				console.error('feature/file FileFeature.getTempDirectory().getRoot()');
					resultOption.onError();
				}
			});
		},
		download : function(option) {
			var resultOption = $.extend({
				'fileUrl' : undefined,
				'directoryEntry' : undefined,
				'fileName' : undefined,
				'onSuccess' : function(downloadedFileEntry) {},
				'onError' : function() {}
			}, option);
			
			CordovaFileFeature.getFile({
				'directoryEntry' : resultOption.directoryEntry,
				'fileName' : resultOption.fileName,
				'neededToCreate' : true,
				'onSuccess' : function(targetFileEntry) {
					CordovaFileFeature.download({
						'sourceUrl' : resultOption.fileUrl,
						'targetFileEntry' : targetFileEntry,
						'onSuccess' : function(downloadedFileEntry) {
							resultOption.onSuccess(downloadedFileEntry);
						},
						'onError' : function() {
							resultOption.onError();
						}
					});
				},
				'onError' : function(error) {
    				console.error('feature/file Inner.data.downloadTempFile() getFile() error : '
    						+ JSON.stringify(error));
					resultOption.onError();
				}
			});
		},
		getFile : function(option) {
			var resultOption = $.extend({
				'directoryEntry' : undefined,
				'fileName' : undefined,
				'neededToCreate' : false,
				'onSuccess' : function(targetFileEntry) {},
				'onNotFound' : function() {},
				'onError' : function(error) {}
			}, option);
			
			CordovaFileFeature.getFile({
				'directoryEntry' : resultOption.directoryEntry,
				'fileName' : resultOption.fileName,
				'neededToCreate' : resultOption.neededToCreate,
				'onSuccess' : function(targetFileEntry) {
					resultOption.onSuccess(targetFileEntry);
				},
				'onNotFound' : function() {
					resultOption.onNotFound();
				},
				'onError' : function(error) {
					console.error('FileFeature.getFile() error : '
							+ JSON.stringify(error));
					resultOption.onError();
				}
			});
		},
		getFileByPath : function(option) {
			var resultOption = $.extend({
				'directoryEntry' : undefined,
				'filePath' : undefined,
				'neededToCreate' : false,
				'onSuccess' : function(targetFileEntry) {},
				'onNotFound' : function() {},
				'onError' : function(error) {}
			}, option);
			
			var directoryPath = Inner.file.toDirectoryPath(resultOption.filePath);
			FileFeature.getDirectoryByPath({
				'parentDirectoryEntry' : resultOption.directoryEntry,
				'directoryPath' : directoryPath,
				'neededToCreate' : resultOption.neededToCreate,
				'onSuccess' : function(directoryEntry) {
					var fileName = Inner.file.toFileName(resultOption.filePath);
					FileFeature.getFile({
						'directoryEntry' : directoryEntry,
						'fileName' : fileName,
						'neededToCreate' : resultOption.neededToCreate,
						'onSuccess' : function(targetFileEntry) {
							resultOption.onSuccess(targetFileEntry);
						},
						'onNotFound' : function() {
							resultOption.onNotFound();
						},
						'onError' : function(error) {
							resultOption.onError();
						}
					});
				},
				'onNotFound' : function() {
					resultOption.onNotFound();
				},
				'onError' : function() {
					resultOption.onError();
				}
			});
		},
		getDirectoryByPath : function(option) {
			var resultOption = $.extend({
				'parentDirectoryEntry' : undefined,
				'directoryPath' : undefined,
				'neededToCreate' : true,
				'onSuccess' : function(directoryEntry) {},
				'onNotFound' : function() {},
				'onError' : function() {}
			}, option);
			
			var directoryPath = resultOption.directoryPath;
			directoryPath = directoryPath.replace(/\/$/, '');
			directoryPath = directoryPath.replace(/^\//, '');
			var parentDirectoryEntry = resultOption.parentDirectoryEntry;
			
			if (directoryPath) {
				var directoryNames = directoryPath.split('/');
				var index = 0;
				var directoryEntry = parentDirectoryEntry;
				LoopUtil.loop({
					'onLoop' : function(toContinue) {
						var directoryName = directoryNames[index];
						
						CordovaFileFeature.getDirectory({
							'directoryEntry' : directoryEntry,
							'directoryName' : directoryName,
							'neededToCreate' : resultOption.neededToCreate,
							'onSuccess' : function(targetDirectoryEntry) {
		    					directoryEntry = targetDirectoryEntry;
		    					
								index++;
								if (index < directoryNames.length) {
			    					toContinue();
								} else {
									resultOption.onSuccess(directoryEntry);
								}
							},
							'onNotFound' : function() {
								resultOption.onNotFound();
							},
							'onError' : function(error) {
			    				console.error('feature/file Inner.data.createDirectoryByPath() error : '
			    						+ JSON.stringify(error));
			    				resultOption.onError();
							}
						});
					},
					'durationMs' : 0
				});
			} else {
				resultOption.onSuccess(parentDirectoryEntry);
			}
		},
        readText: function(option) {
    		var resultOption = $.extend({
				'fileEntry': undefined,
				'onSuccess' : function(text) {},
				'onError' : function() {}
            }, option);
            
            var fileEntry = resultOption.fileEntry;
            
            fileEntry.file(function(file) {
                var reader = new FileReader();
                reader.onloadend = function() {
                    resultOption.onSuccess(this.result);
                };
                reader.readAsText(file);
            }, function(error) {
                console.error('feature/file FileFeature.readText() error : '
                        + JSON.stringify(error));
                resultOption.onError();
            });
        },
        writeText: function(option) {
        	var resultOption = $.extend({
				'fileEntry': undefined,
				'text' : undefined,
				'isAppended' : true,
				'onSuccess' : function() {},
				'onError' : function() {}
            }, option);

		    var fileEntry = resultOption.fileEntry;

		    var data = new Blob([ resultOption.text ], {
		        type: 'text/plain'
		    });

		    fileEntry.createWriter(function(fileWriter) {
		        fileWriter.onwriteend = function() {
		            resultOption.onSuccess();
		        };
		        fileWriter.onerror = function(error) {
                    console.error('feature/file FileFeature.writeText() error : '
                            + JSON.stringify(error));
		            resultOption.onError();
		        };
		        if (resultOption.isAppended) {
		        	fileWriter.seek(fileWriter.length);
		        }
		        fileWriter.write(data);
		    });
		}
    };
    
    var Inner = {
    	data : {
			generateTempFileName : function(option) {
				var resultOption = $.extend({
					'suffix' : 'tmp',
				}, option);
				
				var now = new Date();
				var nowString = DateUtil.toString(now, {
					'format' : 'yyyy-MM-dd_HH-mm-ss'
				});
				var deviceUuid = UrlUtil.getParameter('deviceUuid');
				var fileName = nowString + '_' + deviceUuid + '.' + resultOption.suffix;
				return fileName;
			}
    	},
    	file : {
			toFileName : function(filePath) {
				var fileName = filePath.replace(/.+\//, '');
				return fileName;
			},
			toDirectoryPath : function(filePath) {
				var directoryPath = '';
				var hasMark = false;
				for (var i = filePath.length - 1; i >= 0; i--) {
					var char = filePath[i];
					if (char == '/') {
						hasMark = true;
					}
					
					if (hasMark) {
						directoryPath = char + directoryPath;
					}
				}
				return directoryPath;
			}
    	}
    };
	
	return File;
}();
