!function() {
	window.WeixinFeature = {
		bind: function(option) {
			var resultOption = $.extend({
				onBound: () => {},
				onCanceled: () => {},
				onError: () => {}
			}, option);
			
			Inner.dom.bind();
			Inner.event.setLoginCallback({
				onLogined: (flavor, responseType, code) => {
					if (responseType == 'agree') {
						Inner.data.bindWeixin({
							flavor: flavor,
							code: code,
							onSuccess: () => {
								resultOption.onBound();
							},
							onError: () => {
								resultOption.onError();
							}
						});
					} else {
						resultOption.onCanceled();
					}
				}
			});
		}
	};
	
	var Inner = {
		cache: {
			'onLogined' : undefined,
			'currentOperationId' : undefined
		},
		data: {
			bindWeixin: function(option) {
				var resultOption = $.extend({
					flavor: undefined,
					code: undefined,
					onSuccess: () => {},
					onError: () => {}
				}, option);
				
				var deviceUuid = UrlUtil.getParameter('deviceUuid');
				
				AjaxUtil.execute({
					'url' : '/user/bind/bind-weixin.do',
					'data' : {
						'deviceUuid' : deviceUuid,
						'flavor' : resultOption.flavor,
						'code' : resultOption.code
					},
					'success' : function(data) {
						resultOption.onSuccess();
					},
					'error' : function(error) {
			            console.error('WeixinFeature Inner.data.bindWeixin() error : '
			                    + JSON.stringify(error));
						resultOption.onError();
					}
				});
			}
		},
		dom: {
			bind: function() {
				CordovaPlugin.execute({
		            'serviceName' : 'WeixinPlugin',
		            'methodName' : 'login'
				});
			}
		},
		event: {
			setLoginCallback: function(option) {
				var resultOption = $.extend({
					onLogined: (flavor, responseType, code) => {}
				}, option);
				
				var onLogined = Inner.cache.onLogined;
				if (!onLogined) {
					CordovaPlugin.execute({
			            'serviceName' : 'WeixinPlugin',
			            'methodName' : 'setLoginCallback',
			            'onSuccess' : function(result) {
			            	var onLogined = Inner.cache.onLogined;
			            	if (onLogined) {
				            	onLogined(result.flavor, result.responseType, result.code);
			            	}
			            }
					});
				}
				Inner.cache.onLogined = resultOption.onLogined;
			}
		}
	};
}();
