!function() {
	window.WxpayFeature = {
		payVip : function(option) {
			var resultOption = $.extend({
				onPaid: (userVip, userUsage, userAward, magicTigerPresent) => {},
				onCanceled: () => {},
				onError: () => {},
				onNoWeixin: () => {}
			}, option)
			
			BuildConfigPlugin.getParameterMap({
                'onSuccess' : function(parameterMap) {
                	Inner.data.prepayVip({
    					flavor: parameterMap.flavor,
    					onSuccess: (prepayData) => {
    						Inner.event.setPayCallback({
    							onPaid: (responseType) => {
    								console.log('responseType : ' + responseType)
    								
									Inner.data.updateAfterPay({
										payOrderId: prepayData.payOrderId,
										responseType: responseType,
										onSuccess: (payResultData) => {
		    								if (responseType == 'success') {
		        								resultOption.onPaid(payResultData.userVip,
		        										payResultData.userUsage,
		        										payResultData.userAward,
		        										payResultData.magicTigerPresent)
		    								}
										},
										onError: () => {
											resultOption.onError()
										}
									})
									
    								if (responseType != 'success') {
        								resultOption.onCanceled()
    								}
    							}
    						})
    						Inner.dom.prepay({
    							mchId: prepayData.mchId,
    							prepayId: prepayData.prepayId,
    							randomString: prepayData.randomString,
    							timeStamp: prepayData.timeStamp,
    							sign: prepayData.sign,
    							onNoWeixin: function() {
    								resultOption.onNoWeixin();
    							}
    						})
    					},
    					onError: () => {
    						resultOption.onError()
    					}
                	});
                },
				onError: () => {
					resultOption.onError()
                }
			})
		}
	}
	
	var Inner = {
		cache: {
			onPaid: undefined
		},
		data: {
			prepayVip: function(option) {
				var resultOption = $.extend({
					flavor: undefined,
					onSuccess: (prepayData) => {},
					onError: () => {}
				}, option)
				
				const deviceUuid = UrlUtil.getParameter('deviceUuid')
				AjaxUtil.execute({
					url: '/wxpay/prepay-vip.do',
					data: {
						deviceUuid: deviceUuid,
						flavor: resultOption.flavor
					},
					success: (data) => {
						resultOption.onSuccess(data);
					},
					error: () => {
						resultOption.onError()
					}
				})
			},
			updateAfterPay: function(option) {
				var resultOption = $.extend({
					payOrderId: undefined,
					responseType: undefined,
					onSuccess: (payResultData) => {},
					onError: () => {}
				}, option)
				
				AjaxUtil.execute({
					url: '/wxpay/update-after-pay.do',
					data: {
						payOrderId: resultOption.payOrderId,
						responseType: resultOption.responseType
					},
					success: (data) => {
						resultOption.onSuccess(data)
					},
					error: () => {
						resultOption.onError()
					}
				})
			}
		},
		event: {
			setPayCallback: function(option) {
				var resultOption = $.extend({
					onPaid: (responseType) => {}
				}, option)
				
				var onPaid = Inner.cache.onPaid;
				if (!onPaid) {
					CordovaPlugin.execute({
			            'serviceName' : 'WxpayPlugin',
			            'methodName' : 'setPayCallback',
			            'onSuccess' : function(result) {
			            	var onPaid = Inner.cache.onPaid;
			            	if (onPaid) {
			            		onPaid(result.responseType);
			            	}
			            }
					})
				}
				Inner.cache.onPaid = resultOption.onPaid
			}
		},
		dom: {
			prepay: function(option) {
				var resultOption = $.extend({
					mchId: undefined,
					prepayId: undefined,
					randomString: undefined,
					timeStamp: undefined,
					sign: undefined,
					onNoWeixin: function() {}
				}, option)
				
				CordovaPlugin.execute({
		            serviceName: 'WxpayPlugin',
		            methodName: 'prepay',
		            parameters: [ resultOption.mchId, resultOption.prepayId,
		            	resultOption.randomString, resultOption.timeStamp,
		            	resultOption.sign ],
	                onSuccess: function(result) {
	                	if (result.error == 'noWeixin') {
	                		resultOption.onNoWeixin();
	                	}
	                }
				})
			}
		}
	}
}()
