!function() {
	window.WxshareFeature = {
		shareMp(option) {
			var resultOption = $.extend({
				mpType: 'test', // test=测试版、preview=体验版、release=正式版
				mpOriginalId: undefined,
				pagePath: '',
				title: undefined,
				description: undefined,
				thumbnailUrl: undefined,
				onNoWeixin: () => {}
			}, option)
			
			var thumbnailSize = Inner.variable.thumbnailSize
			
			LoadFeature.loadFile({
				'fileUrl' : resultOption.thumbnailUrl,
				'onLoad' : (filePath, fileEntry) => {
					var thumbnailFilePath = Inner.file.toFilePath(fileEntry);
					
					CordovaPlugin.execute({
			            serviceName: 'WxsharePlugin',
			            methodName: 'shareMp',
			            parameters: [ resultOption.mpType, resultOption.mpOriginalId,
			            	resultOption.pagePath, resultOption.title,
			            	resultOption.description, thumbnailFilePath,
			            	thumbnailSize ],
		                onSuccess: (result) => {
		                	if (result.error == 'noWeixin') {
		                		resultOption.onNoWeixin()
		                	}
		                }
					})
				}
			})
		},
		shareImage(option) {
			var resultOption = $.extend({
				imageUrl: undefined,
				scene: 'session', // session=对话、timeline=朋友圈、favorite=收藏
				onError: () => {},
				onNoWeixin: () => {}
			}, option)
			
			var thumbnailSize = Inner.variable.thumbnailSize
			console.log('resultOption.scene : ' + resultOption.scene);
			
			LoadFeature.loadFile({
				'fileUrl' : resultOption.imageUrl,
				'onLoad' : (filePath, fileEntry) => {
					var nativeFilePath = Inner.file.toFilePath(fileEntry);
					
					CordovaPlugin.execute({
			            serviceName: 'WxsharePlugin',
			            methodName: 'shareImage',
			            parameters: [ nativeFilePath, thumbnailSize, resultOption.scene ],
		                onSuccess: (result) => {
		                	if (result.error == 'noWeixin') {
		                		resultOption.onNoWeixin();
		                	}
		                }
					})
				},
				'onError' : () => {
					resultOption.onError();
				}
			})
		}
	}
	
	var Inner = {
		variable: {
			thumbnailSize: 200
		},
		file : {
			toFilePath: function(fileEntry) {
				var filePath = fileEntry.nativeURL;
				filePath = filePath.replace('file://', '');
				filePath = filePath.substring(0, filePath.lastIndexOf('/') + 1)
				
				var fileName = fileEntry.name;
				filePath += fileName;
				
				return filePath;
			}
		}
	}
}();
