!function() {
	window.LoadFeature = {
		loadFile : function(option) {
			var resultOption = $.extend({
				'fileUrl' : undefined,
				'neededToCover' : false,
				'onLoad' : function(filePath, fileEntry) {},
				'onError' : function() {}
			}, option);
			
			var fileUrl = resultOption.fileUrl;
			
			LoadFeature.loadFiles({
				'fileUrls' : [ fileUrl ],
				'neededToCover' : resultOption.neededToCover,
				'onAllLoad' : function(fileUrlAndPathMap, fileUrlAndEntryMap) {
					var filePath = fileUrlAndPathMap[fileUrl];
					var fileEntry = fileUrlAndEntryMap[fileUrl];
					resultOption.onLoad(filePath, fileEntry);
				},
				'onError' : function() {
					resultOption.onError();
				}
			});
		},
		loadFiles : function(option) {
			var resultOption = $.extend({
				'fileUrls' : [],
				'forceToLoadFileUrls' : [],
				'neededToCover' : false,
				'onProcess' : function(loadedCount) {}, // 每上传一个文件，触发此方法一次
				'onAllLoad' : function(fileUrlAndPathMap, fileUrlAndEntryMap) {}, // 当上传完所有文件后，触发此方法
				'onError' : function() {}
			}, option);
			
			var fileUrls = resultOption.fileUrls;
			var forceToLoadFileUrls = resultOption.forceToLoadFileUrls;

			var totalCount = fileUrls.length;
			var loadedCount = 0;
			var fileUrlAndPathMap = {};
			var fileUrlAndEntryMap = {};
			$.each(fileUrls, function(index, fileUrl) {
				var forceToDownload = forceToLoadFileUrls.some(function(item) {
                    return item == fileUrl;
				});
				Inner.data.download({
					'fileUrl' : fileUrl,
					'forceToDownload' : forceToDownload,
					'onSuccess' : function(downloadedFilePath, fileEntry) {
						fileUrlAndPathMap[fileUrl] = downloadedFilePath;
						fileUrlAndEntryMap[fileUrl] = fileEntry;

						loadedCount++;
						resultOption.onProcess(loadedCount);
						
						if (loadedCount == totalCount) {
							resultOption.onAllLoad(fileUrlAndPathMap, fileUrlAndEntryMap);
						}
					},
					'onError' : function() {
						resultOption.onError();
					}
				});
			});
		},
		getTempDirectory : function(option) {
            var resultOption = $.extend({
                'onSuccess' : function(tempDirectory) {},
                'onError' : function() {}
            }, option);

            FileFeature.getTempDirectory({
                'fileNameKey' : Inner.variable.tempFileNameKey,
                'onSuccess' : function(tempDirectory) {
                    resultOption.onSuccess(tempDirectory);
                },
                'onError' : function() {
                    resultOption.onError();
                }
            });
		}
	};
	
	var Inner = {
		variable : {
			'tempFileNameKey' : 'load'
		},
		cache : {
			'loadOption' : undefined
		},
		data : {
			download : function(option) {
				var resultOption = $.extend({
					'fileUrl' : undefined,
					'forceToDownload' : false,
					'onSuccess' : function(downloadedFilePath, fileEntry) {},
					'onError' : function() {}
				}, option);
				
				var fileUrl = resultOption.fileUrl;
				var forceToDownload = resultOption.forceToDownload;

				FileFeature.getTempDirectory({
					'fileNameKey' : Inner.variable.tempFileNameKey,
					'onSuccess' : function(tempDirectory) {
						var directoryPath = Inner.data.getDirectoryPath(fileUrl);
						var fileName = Inner.data.getFileName(fileUrl);
						
						FileFeature.getDirectoryByPath({
							'parentDirectoryEntry' : tempDirectory,
							'directoryPath' : directoryPath,
							'onSuccess' : function(directoryEntry) {
								if (forceToDownload) {
								    var resizeFileUrl;
                                    var isImageFile = Inner.data.isImageFile(fileName);
                                    if (isImageFile) {
                                        resizeFileUrl = UrlUtil.appendImageResizeSuffix(
                                                fileUrl);
                                    } else {
                                        resizeFileUrl = fileUrl;
                                    }
                                    FileFeature.download({
                                        'fileUrl' : resizeFileUrl,
                                        'directoryEntry' : directoryEntry,
                                        'fileName' : fileName,
                                        'onSuccess' : function(downloadedFileEntry) {
                                            var downloadedFilePath =
                                                    downloadedFileEntry.toInternalURL();
                                            resultOption.onSuccess(downloadedFilePath, downloadedFileEntry);
                                        },
                                        'onError' : function() {
                                            resultOption.onError();
                                        }
                                    });
								} else {
                                    FileFeature.getFile({
                                        'directoryEntry' : directoryEntry,
                                        'fileName' : fileName,
                                        'onSuccess' : function(targetFileEntry) {
                                            var filePath = targetFileEntry.toInternalURL();
                                            resultOption.onSuccess(filePath, targetFileEntry);
                                        },
                                        'onNotFound' : function() {
                                            var resizeFileUrl;
                                            var isImageFile = Inner.data.isImageFile(fileName);
                                            if (isImageFile) {
                                                resizeFileUrl = UrlUtil.appendImageResizeSuffix(
                                                        fileUrl);
                                            } else {
                                                resizeFileUrl = fileUrl;
                                            }
                                            FileFeature.download({
                                                'fileUrl' : resizeFileUrl,
                                                'directoryEntry' : directoryEntry,
                                                'fileName' : fileName,
                                                'onSuccess' : function(downloadedFileEntry) {
                                                    var downloadedFilePath =
                                                            downloadedFileEntry.toInternalURL();
                                                    resultOption.onSuccess(downloadedFilePath, downloadedFileEntry);
                                                },
                                                'onError' : function() {
                                                    resultOption.onError();
                                                }
                                            });
                                        },
                                        'onError' : function(error) {
                                            resultOption.onError();
                                        }
                                    });
								}
							},
							'onError' : function() {
								resultOption.onError();
							}
						});
					},
					'onError' : function() {
						resultOption.onError();
					}
				});
			},
			getFileName : function(url) {
				var fileName = url.replace(/\?.*/, '');
				fileName = fileName.replace(/.*\//, '');
				return fileName;
			},
			getDirectoryPath : function(url) {
				var directoryPath = url.replace(/http[s]*.*\/\/[^/]*\//, '/');
				directoryPath = directoryPath.replace(/\?.*/, '');
				
				var fileName = Inner.data.getFileName(url);
				directoryPath = directoryPath.replace(fileName, '');
				
				return directoryPath;
			},
			isImageFile : function(fileName) {
				if (StringUtil.contains(fileName, '.jpg')
						|| StringUtil.contains(fileName, '.jpeg')
						|| StringUtil.contains(fileName, '.png')) {
					return true;
				} else {
					return false;
				}
			}
		}
	};
}();
