!function() {
	window.ResourceFeature = {
		copyResource: function(option) {
            var resultOption = $.extend({
                'beforeCopy' : function(neededToCopy) {},
                'onSuccess' : function() {}
            }, option);

            Inner.data.neededToCopy({
                'onSuccess' : function(neededToCopy) {
                    resultOption.beforeCopy(neededToCopy);
                    if (neededToCopy) {
                        Inner.file.copyResourceDirectory({
                            'onSuccess' : function() {
                                Inner.file.writeCopyVersion({
                                    'onSuccess' : function() {
                                        resultOption.onSuccess();
                                    }
                                });
                            }
                        });
                    } else {
                        resultOption.onSuccess();
                    }
                }
            });
		}
	}

	var Inner = {
        variable: {
            'fileNameKey' : 'resource'
        },
		data : {
            neededToCopy: function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function(neededToCopy) {}
                }, option);

                Inner.data.getCopyVersion({
                    'onSuccess' : function(copyVersion) {
                        Inner.data.getAppVersion({
                            'onSuccess' : function(appVersion) {
                                var neededToCopy = (appVersion != copyVersion);
                                resultOption.onSuccess(neededToCopy);
                            }
                        });
                    }
                })
            },
			getAppVersion : function(option) {
				var resultOption = $.extend({
					'onSuccess' : function(appVersion) {}
				}, option);

                BuildConfigPlugin.getParameterMap({
                    'onSuccess' : function (parameterMap) {
                        resultOption.onSuccess(parameterMap.versionName);
                    }
                });
			},
            getCopyVersion : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function(copyVersion) {}
                }, option);

                Inner.file.getCopyVersionFile({
                    'onSuccess' : function(copyVersionFile) {
                        FileFeature.readText({
                            'fileEntry' : copyVersionFile,
                            'onSuccess' : function(text) {
                                resultOption.onSuccess(text);
                            },
                            'onError' : function() {
                                resultOption.onError();
                            }
                        });
                    }
                });
            }
		},
		file : {
            getCopyVersionFile : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function(copyVersionFile) {}
                }, option);

                LoadFeature.getTempDirectory({
                    'onSuccess' : function(tempDirectory) {
                        FileFeature.getFile({
                            'directoryEntry' : tempDirectory,
                            'fileName' : 'copy-version.txt',
                            'neededToCreate' : true,
                            'onSuccess' : function(targetFileEntry) {
                                resultOption.onSuccess(targetFileEntry);
                            }
                        });
                    }
                });
            },
            copyResourceDirectory : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function() {}
                }, option);

                CordovaFileFeature.getAssetDirectory({
                    'onSuccess' : function(assetDirectoryEntry) {
                        FileFeature.getDirectoryByPath({
                            'parentDirectoryEntry' : assetDirectoryEntry,
                            'directoryPath' : 'resource',
                            'neededToCreate' : false,
                            'onSuccess' : function(resourceDirectory) {
                                LoadFeature.getTempDirectory({
                                    'onSuccess' : function(tempDirectory) {
                                        var directoryReader = resourceDirectory.createReader();
                                        directoryReader.readEntries(function(entries) {
                                            if (entries.length == 0) {
                                                resultOption.onSuccess();
                                            } else {
                                                var copiedCount = 0;
                                                $.each(entries, function(index, entry) {
                                                    var fileOrDirectory = (entry.isFile
                                                            ? 'file' : 'directory');
                                                    Inner.file.removeOnExisted({
                                                        'directoryEntry' : tempDirectory,
                                                        'fileName' : entry.name,
                                                        'fileOrDirectory' : fileOrDirectory,
                                                        'onSuccess' : function() {
                                                            CordovaFileFeature.copy({
                                                                'fileEntry' : entry,
                                                                'parentDirectry' : tempDirectory,
                                                                'onSuccess' : function() {
                                                                    copiedCount++;
                                                                    if (copiedCount == entries.length) {
                                                                        resultOption.onSuccess();
                                                                    }
                                                                }
                                                            })
                                                        }
                                                    });
                                                });
                                            }
                                        });
                                    }
                                });
                            }
                        })
                    }
                });
            },
            writeCopyVersion : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function() {}
                }, option);

                Inner.file.getCopyVersionFile({
                    'onSuccess' : function(copyVersionFile) {
                        Inner.data.getAppVersion({
                            'onSuccess' : function(appVersion) {
                                FileFeature.writeText({
                                    'fileEntry': copyVersionFile,
                                    'text' : appVersion,
                                    'onSuccess' : function() {
                                        resultOption.onSuccess();
                                    }
                                });
                            }
                        });
                    }
                });
            },
            removeOnExisted: function(option) {
                var resultOption = $.extend({
                    'directoryEntry' : undefined,
                    'fileName' : undefined,
                    'fileOrDirectory' : 'file',
                    'onSuccess' : function() {}
                }, option);

                var fileOrDirectory = resultOption.fileOrDirectory;
                var directoryEntry = resultOption.directoryEntry;
                var fileName = resultOption.fileName;

                if (fileOrDirectory == 'file') {
                    FileFeature.getFile({
                        'directoryEntry' : directoryEntry,
                        'fileName' : fileName,
                        'neededToCreate' : false,
                        'onSuccess' : function(fileEntry) {
                            CordovaFileFeature.remove({
                                'fileEntry' : fileEntry,
                                'onSuccess' : function() {
                                    resultOption.onSuccess();
                                }
                            });
                        },
                        'onNotFound' : function() {
                            resultOption.onSuccess();
                        }
                    });
                } else {
                    FileFeature.getDirectoryByPath({
                        'parentDirectoryEntry' : directoryEntry,
                        'directoryPath' : fileName,
                        'neededToCreate' : false,
                        'onSuccess' : function(directoryEntry) {
                            CordovaFileFeature.remove({
                                'fileEntry' : directoryEntry,
                                'onSuccess' : function() {
                                    resultOption.onSuccess();
                                }
                            });
                        },
                        'onNotFound' : function() {
                            resultOption.onSuccess();
                        }
                    });
                }
            }
		}
	};
}();
