!function() {
    setTimeout(function() {
        Inner.dom.loopToShowProgressPoint();
    });

    var beginDate = new Date();
	document.addEventListener('deviceready', function() {
	    Inner.dom.readyErrorPopupLink();
	    Inner.dom.readyUpgradePopupLink();

	    Inner.data.getModel({
	        'onSuccess' : function() {
                Inner.dom.setProgress({
                    'percent' : 80,
                    'durationMs' : 1000
                });
                Inner.dom.checkNetToRedirect({
                    'onError' : function() {
                        Inner.dom.alertOnNetError();
                    }
                });
	        }
	    });
	}, false);

	var Inner = {
		variable : {
		    'test' : {
//			    'backServerUrl' : 'http://172.20.10.2:81',
//			    'backServerUrl' : 'http://192.168.1.104:81',
			    'backServerUrl' : 'http://android-back-test.huibenxia.com'
		    },
		    'product' : {
    			'backServerUrl' : 'https://android-back.huibenxia.com'
		    }
		},
		cache : {
		    'model' : undefined,
		    'pageData' : undefined,
		    'stopProgressLoop' : false
		},
		data : {
		    getModel : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function() {}
                }, option);

		        var model = ManifestPlugin.getMetaData({
                    'key' : 'model',
                    'onSuccess' : function(value) {
		                Inner.cache.model = value;
		                resultOption.onSuccess();
                    }
		        });
		    },
            loadInitData : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function() {},
                    'onNeededToUpgrade' : function() {},
                    'onError' : function() {}
                }, option);

                BuildConfigPlugin.getParameterMap({
                    'onSuccess' : function (parameterMap) {
                        var width = screen.availWidth;
                        var height = screen.availHeight;
                        var dpr = window.devicePixelRatio;

                        var navigatorParameters = [ 'appCodeName', 'appName', 'appVersion',
                            'connection', 'userAgent' ];
                        var navigatorMap = {};
                        $.each(navigatorParameters, function(index, parameter) {
                            navigatorMap[parameter] = navigator[parameter];
                        });

                        var size = {
                           'width' : width,
                           'height' : height,
                           'dpr' : dpr
                        };

                        var data = {
                            'deviceUuid' : device.uuid,
                            'buildConfigParameterMap' : parameterMap,
                            'navigator' : navigatorMap,
                            'size' : size
                        };
                        var dataJson = JSON.stringify(data);

                        var url = '/app/load-init-data.do';
                        console.log('pageData input : ' + JSON.stringify(dataJson));
                        Inner.ajax.executeWithRetry({
                            url,
                            'data' : dataJson,
                            'onSuccess' : function(data) {
                                Inner.cache.pageData = data;
                                console.log('pageData output : ' + JSON.stringify(data));
                                if (data.neededToUpgrade) {
                                    resultOption.onNeededToUpgrade(data.apkUrl, data.marketPackage);
                                } else {
                                    resultOption.onSuccess();
                                }
                            },
                            'onError' : function(error) {
                                console.error(JSON.stringify(error));
                                console.error('url : ' + url);
                                resultOption.onError();
                            },
                            'retryDurationMs' : 3000,
                            'retryMaxCount' : 3
                        });
                    }
                });
            },
            readyToLoadResource : function() {
                var pageData = Inner.cache.pageData;
                var sessionCode = pageData.sessionCode;

                var url = '/app/ready-to-load-resource.do';
                Inner.ajax.execute({
                    url,
                    'data' : {
                        'deviceUuid' : device.uuid,
                        'sessionCode' : sessionCode
                    },
                    'error' : function(e) {
                        console.error(JSON.stringify(e));
                        console.error('url : ' + url);
                    }
                });
            },
            recordOnLoad : function() {
                var pageData = Inner.cache.pageData;
                var sessionCode = pageData.sessionCode;

                var url = '/app/record-on-load.do';
                Inner.ajax.execute({
                    url,
                    'data' : {
                        'deviceUuid' : device.uuid,
                        'sessionCode' : sessionCode
                    },
                    'error' : function(e) {
                        console.error(JSON.stringify(e));
                        console.error('url : ' + url);
                    }
                });
            },
		    loadResources : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function() {},
                    'onError' : function() {}
                }, option);

                var pageData = Inner.cache.pageData;
                var sessionCode = pageData.sessionCode;

                var loadFileUrls = Inner.cache.pageData.loadFileUrls;
			    if (loadFileUrls.length == 0) {
                    resultOption.onSuccess();
                } else {
                    LoadFeature.loadFiles({
                        'fileUrls' : loadFileUrls,
                        'forceToLoadFileUrls' : Inner.cache.pageData.forceToLoadFileUrls,
                        'onAllLoad' : function(fileUrlAndPathMap) {
                            resultOption.onSuccess();
                        }, // 当上传完所有文件后，触发此方法
                        'onError' : function() {
                            resultOption.onError();
                        }
                    });
                }
		    },
		    getLocalLoadFileVersionFile : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function(loadFileVersionFile) {},
                    'onError' : function() {}
                }, option);

		        LoadFeature.getTempDirectory({
                    'onSuccess' : function(tempDirectory) {
                        FileFeature.getFile({
                            'directoryEntry' : tempDirectory,
                            'fileName' : 'load-file-version.txt',
                            'neededToCreate' : true,
                            'onSuccess' : function(targetFileEntry) {
                                resultOption.onSuccess(targetFileEntry);
                            },
                            'onError' : function(error) {
                                resultOption.onError();
                            }
                        });
                    },
                    'onError' : function() {}
		        });
		    },
            getLocalLoadFileVersion : function(option) {
                var resultOption = $.extend({
                    'onSuccess' : function(localLoadFileVersion) {},
                    'onError' : function() {}
                }, option);

                Inner.data.getLocalLoadFileVersionFile({
                     'onSuccess' : function(loadFileVersionFile) {
                        FileFeature.readText({
                            'fileEntry' : loadFileVersionFile,
                            'onSuccess' : function(text) {
                                resultOption.onSuccess(text);
                            },
                            'onError' : function() {
                                resultOption.onError();
                            }
                        });
                     },
                     'onError' : function() {
                        resultOption.onError();
                     }
                });
            },
            writeLoadFileVersion: function(option) {
                var resultOption = $.extend({
                    'newLoadFileVersion' : undefined,
                    'onSuccess' : function() {},
                    'onError' : function() {}
                }, option);

                Inner.data.getLocalLoadFileVersionFile({
                    'onSuccess' : function(loadFileVersionFile) {
                        FileFeature.writeText({
                            'fileEntry': loadFileVersionFile,
                            'text' : resultOption.newLoadFileVersion,
                            'onSuccess' : function() {
                                resultOption.onSuccess();
                            },
                            'onError' : function() {
                                resultOption.onError();
                            }
                        });
                    },
                    'onError' : function() {
                        resultOption.onError();
                    }
                });
            }
		},
		dom : {
		    checkNetToRedirect : function(option) {
                var resultOption = $.extend({
                    'onError' : function() {}
                }, option);

	            var isOnline = Inner.net.isOnline();
	            if (isOnline) {
                    Inner.data.loadInitData({
                        'onNeededToUpgrade' : function() {
                            Inner.dom.alertToUpgrade();
                        },
                        'onSuccess' : function() {
                            Inner.dom.doAfterLoadInitData({
                                'onError' : function() {
                                    resultOption.onError();
                                }
                            });
                        },
                        'onError' : function() {
                            resultOption.onError();
                        }
                    });
	            } else {
                    resultOption.onError();
	            }
		    },
		    doAfterLoadInitData : function(option) {
                var resultOption = $.extend({
                    'onError' : function() {}
                }, option);

		        var newLoadFileVersion = Inner.cache.pageData.loadFileVersion;
		        Inner.data.getLocalLoadFileVersion({
                    'onSuccess' : function(localLoadFileVersion) {
                        Inner.data.readyToLoadResource();
                        var isVersionChanged = (localLoadFileVersion != newLoadFileVersion);
                        if (isVersionChanged) {
                            ResourceFeature.copyResource({
                                'beforeCopy' : function(neededToCopy) {
                                    var durationMs = (isVersionChanged ? 6000 : 10);
                                    Inner.dom.setProgress({
                                        'percent' : 100,
                                        'durationMs' : durationMs
                                    });
                                },
                                'onSuccess' : function() {
                                    Inner.data.loadResources({
                                        'onSuccess' : function() {
                                            Inner.data.writeLoadFileVersion({
                                                'newLoadFileVersion' : newLoadFileVersion
                                            });
                                            Inner.dom.redirectWebPage();
                                        },
                                        'onError' : function() {
                                            resultOption.onError();
                                        }
                                    });
                                }
                            });
                        } else {
                            Inner.dom.redirectWebPage();
                        }
                    },
                    'onError' : function() {
                        resultOption.onError();
                    }
                });
		    },
		    readyErrorPopupLink : function() {
                var popup = $('.inner-index-error-popup');
                var showClassName = 'inner-index-popup-show';

                var link = popup.find('.inner-index-popup-link');
                link.click(function() {
                    popup.removeClass(showClassName);

                    Inner.dom.loopToShowProgressPoint();
                    Inner.dom.checkNetToRedirect({
                        'onError' : function() {
                            setTimeout(function() {
                                Inner.dom.alertOnNetError();
                            }, 600);
                        }
                    });
                });
		    },
            alertOnNetError : function() {
                Inner.dom.setProgress({
                    'percent' : 0
                });

                var popup = $('.inner-index-error-popup');
                var showClassName = 'inner-index-popup-show';
                setTimeout(function() {
                    popup.addClass(showClassName);
                }, 300);

                Inner.cache.stopProgressLoop = true;
            },
			redirectWebPage : function() {
			    var model = Inner.cache.model;
				var pageUrl = Inner.cache.pageData.pageUrl;
				var pageData = Inner.cache.pageData;
				var sessionCode = pageData.sessionCode;

				var deviceUuid = device.uuid;
				pageUrl += '?model=' + model;
				pageUrl += '&sessionCode=' + sessionCode;
				pageUrl += '&containerType=android';
				pageUrl += '&deviceUuid=' + deviceUuid;

                Inner.dom.readyToPreventBack();
                $('body').addClass('inner-index-body-backstage');

                Inner.data.recordOnLoad();

                var endDate = new Date();
                var durationMs = endDate.getTime() - beginDate.getTime();
                console.log('Index durationMs : ' + durationMs);

                cordova.InAppBrowser.open(pageUrl, '_self',
                        'location=no,fullscreen=yes,hardwareback=no');
			},
			readyToPreventBack : function() {
			    document.addEventListener("backbutton", function(event) {
			        navigator.app.exitApp();
			    });
			},
			loopToShowProgressPoint : function() {
                var placeholder = $('.inner-index-progress-point-placeholder');
                var count = 3;
                Inner.cache.stopProgressLoop = false;
                Inner.event.loop({
                    'onLoop' : function(toContinue) {
                        count--;
                        if (count < 0) {
                            count = 3;
                        }

                        var width = count * 30 + '%';
                        placeholder.css('width', width);

                        if (!Inner.cache.stopProgressLoop) {
                            toContinue();
                        }
                    },
                    'durationMs' : 600,
                    'neededExecuteRightNow' : true
                });
            },
            setProgress : function(option) {
                var resultOption = $.extend({
                     'percent' : undefined,
                     'durationMs' : 200
                }, option);

                var bar = $('.inner-index-progress-bar');
                bar.css('transition-duration', resultOption.durationMs + 'ms');
                bar.css('width', resultOption.percent + '%');
            },
            readyUpgradePopupLink : function() {
                var popup = $('.inner-index-upgrade-popup');
                var showClassName = 'inner-index-popup-show';

                var link = popup.find('.inner-index-popup-link');
                link.click(function() {
                    popup.removeClass(showClassName);
                    Inner.app.upgrade();
                });
            },
            alertToUpgrade : function() {
                var popup = $('.inner-index-upgrade-popup');
                var showClassName = 'inner-index-popup-show';
                setTimeout(function() {
                    popup.addClass(showClassName);
                }, 300);

                Inner.cache.stopProgressLoop = true;

                document.addEventListener('resume', function() {
                    Inner.dom.alertToUpgrade();
                });
            }
		},
        net : {
            isOnline : function() {
                var connectionType = navigator.network.connection.type;
                if (connectionType == Connection.NONE) {
                    return false;
                } else {
                    return true;
                }
            }
        },
        event : {
            loop : function(option) {
                var resultOption = $.extend({
                    'onLoop' : function(toContinue) {},
                    'durationMs' : 1000,
                    'neededExecuteRightNow' : true
                }, option);

                var loopAction = function(newDurationMs) {
                    var durationMs = (newDurationMs > 0
                            ? newDurationMs
                            : resultOption.durationMs);
                    setTimeout(function() {
                        resultOption.onLoop(function(durationMs) {
                            loopAction(durationMs);
                        });
                    }, durationMs);
                };
                if (resultOption.neededExecuteRightNow) {
                    resultOption.onLoop(function(newDurationMs) {
                        loopAction(newDurationMs);
                    });
                } else {
                    setTimeout(function() {
                        resultOption.onLoop(function(newDurationMs) {
                            loopAction(newDurationMs);
                        });
                    }, resultOption.durationMs);
                }
            }
        },
        ajax : {
            execute	: function(option) {
                var resultOption = $.extend({
                    'url'	: undefined,
                    'data'	: {},
                    'success'	: function(data) {},
                    'error'	: function(error) {},
                    'complete'	: function() {}
                }, {
                    'contentType'	: 'application/json;',
                    'type'	: 'POST'
                }, option);

                var data = resultOption.data;
                var type = resultOption.type;

                var model = Inner.cache.model;
                var backServerUrl = Inner.variable[model].backServerUrl;
                var url = resultOption.url;
                resultOption.url = backServerUrl + resultOption.url;

                if (type == 'POST') {
                    if (data && !TypeUtil.isString(data)) {
                        resultOption.data = JSON.stringify(data);
                    }
                }

                $.ajax(resultOption);
            },
            executeWithRetry : function(option) {
                var resultOption = $.extend({
                    'url' : undefined,
                    'data' : {},
                    'onSuccess' : function(data) {},
                    'onError' : function(error) {},
                    'timeoutMs' : 5000,
                    'retryDurationMs' : 1000,
                    'retryMaxCount' : 3
                }, option);

                var retryCount = 0;
                Inner.event.loop({
                    'onLoop' : function(toContinue) {
                        retryCount++;
                        Inner.ajax.execute({
                            'url' : resultOption.url,
                            'data' : resultOption.data,
                            'success' : function(data) {
                                resultOption.onSuccess(data);
                            },
                            'timeout' : resultOption.timeoutMs,
                            'error' : function(error) {
                                if (retryCount <= resultOption.retryMaxCount) {
                                    toContinue();
                                } else {
                                    resultOption.onError(error);
                                }
                            }
                        });
                    },
                    'durationMs' : resultOption.retryDurationMs,
                    'neededExecuteRightNow' : true
                });
            }
        },
        file : {
            removeOnExisted: function(option) {
                var resultOption = $.extend({
                    'directoryEntry' : undefined,
                    'fileName' : undefined,
                    'fileOrDirectory' : 'file',
                    'onSuccess' : function() {}
                }, option);

                var fileOrDirectory = resultOption.fileOrDirectory;
                var directoryEntry = resultOption.directoryEntry;
                var fileName = resultOption.fileName;

                if (fileOrDirectory == 'file') {
                    FileFeature.getFile({
                        'directoryEntry' : directoryEntry,
                        'fileName' : fileName,
                        'neededToCreate' : false,
                        'onSuccess' : function(fileEntry) {
                            CordovaFileFeature.remove({
                                'fileEntry' : fileEntry,
                                'onSuccess' : function() {
                                    resultOption.onSuccess();
                                }
                            });
                        },
                        'onNotFound' : function() {
                            resultOption.onSuccess();
                        }
                    });
                } else {
                    FileFeature.getDirectoryByPath({
                        'parentDirectoryEntry' : directoryEntry,
                        'directoryPath' : fileName,
                        'neededToCreate' : false,
                        'onSuccess' : function(directoryEntry) {
                            CordovaFileFeature.remove({
                                'fileEntry' : directoryEntry,
                                'onSuccess' : function() {
                                    resultOption.onSuccess();
                                }
                            });
                        },
                        'onNotFound' : function() {
                            resultOption.onSuccess();
                        }
                    });
                }
            },
            toFilePath: function(fileEntry) {
                var filePath = fileEntry.nativeURL;
                filePath = filePath.replace('file://', '');
                filePath = filePath.substring(0, filePath.lastIndexOf('/') + 1)

                var fileName = fileEntry.name;
                filePath += fileName;

                return filePath;
            }
        },
        app: {
            upgrade: function(option) {
                var resultOption = $.extend({
                    'onError' : function() {}
                }, option);

                var pageData = Inner.cache.pageData;
                CordovaTool.plugin.execute({
                    'serviceName' : 'UpgradePlugin',
                    'methodName' : 'upgrade',
                    'parameters' : [ pageData.apkUrl, pageData.isWithoutMarket, pageData.marketPackage ],
                    'onError' : function(error) {
                        console.error('index Inner.app.upgrade() error : '
                                + JSON.stringify(error));
                        resultOption.onError();
                    }
                });
            }
        }
	};
}();
